use crate::runtime::{
    Reference,
    acquire, release,
};
use crate::tag;
use super::record;

pub struct Record {
    managed:bool,
    addr:Reference,
}
impl Record {
    pub fn new(schema:usize) -> Result<Self,()>
    {
        //if get_schema(schema) {
        Ok(Self {
            managed:true,
            addr:unsafe {acquire(record())},
        })
        //} else {
        //    Err(())
        //}
    }

    pub fn from(addr:Reference) -> Result<Self,()>
    {
        return if(unsafe {type_key(addr.class)} == tag::Record) {
            Ok(Self { managed:false, addr:addr })
        }
        else {
            Err(())
        }
    }

    //pub fn set(key, Reference)
    //pub fn get(key) -> Reference
}
impl std::ops::Deref for Record {
    type Target = Reference;
    fn deref(&self) -> &Self::Target { return &self.addr; }
}
impl Drop for Record {
    fn drop(&mut self) { if self.managed { unsafe {release(self.addr)}; } }
}
